Name:           sflphone
Version:        1.4.1
Release:        35%{?dist}
Summary:        SIP/IAX2 compatible enterprise-class software phone

License:        GPLv3+
URL:            https://gitlab.savoirfairelinux.com/sfl-ports/sflphone
# Note: the number in the URL is different for every release
Source0:        https://projects.savoirfairelinux.com/attachments/download/14805/%{name}-%{version}.tar.gz
# Install icon to hicolor/scalable/apps
Patch0:         sflphone_icondir.patch
# Unbundle pjproject
Patch1:         sflphone_unbundle.patch
# ZRTP API changes
Patch2:         sflphone_zrtp.patch
# Workaround for bad #includes in zrtp headers, see https://github.com/wernerd/ZRTPCPP/pull/19
Patch3:         sflphone_zrtp-includes.patch
# Disable video support in kde interface (video is not available without ffmpeg)
Patch4:         sflphone_novideo.patch
# Fix gcc5 FTBFS issues
Patch5:         sflphone_gcc5.patch
# Install sflphoned in libexecdir
Patch6:         sflphone_sflphoned-dir.patch
# Fix incorrect conditional in SipTransport::createTlsListener
Patch7:         sflphone_tls.patch
# Fix memory corruption due to keeping pointer to local variable after scope ended
Patch8:         sflphone_memory-corruption.patch
# Fix GCC6 FTBFS due to "error: the compiler can assume that the address of 'other' will always evaluate to 'true'"
Patch9:         sflphone_gcc6.patch
# Fix GCC7 FTBFS due to
# - ISO C++ forbids flexible array member 'm_Data' [-Werror=pedantic]
# - error: this statement may fall through [-Werror=implicit-fallthrough=]
Patch10:        sflphone_gcc7.patch
# Fix FTBFS due to ERROR: The token "BOOL" is deprecated; use "BOOLEAN" instead
Patch11:        sflphone_dbus.patch
# Adapt to pjsip API change
Patch12:        sflphone-pjspi-api-change.patch
# Fix GCC8 FTBFS
Patch13:        sflphone_gcc8.patch
# Fix GCC9 FTBFS
Patch14:        sflphone_gcc9.patch

BuildRequires:  alsa-lib-devel
BuildRequires:  ccrtp-devel
BuildRequires:  check-devel
BuildRequires:  clutter-gtk-devel
BuildRequires:  cmake
BuildRequires:  dbus-glib-devel
BuildRequires:  dbus-c++-devel
BuildRequires:  desktop-file-utils
BuildRequires:  expat-devel
BuildRequires:  evolution-data-server-devel
BuildRequires:  gcc-c++
BuildRequires:  gettext
BuildRequires:  gnome-common
BuildRequires:  gnome-doc-utils
BuildRequires:  gnutls-devel
BuildRequires:  gsm-devel
BuildRequires:  iaxclient-libiax-devel
BuildRequires:  ilbc-devel
BuildRequires:  intltool
BuildRequires:  kdepimlibs-devel
BuildRequires:  libnotify-devel
BuildRequires:  libsamplerate-devel
BuildRequires:  libsexy-devel
BuildRequires:  libsndfile-devel
BuildRequires:  libtool
BuildRequires:  libyaml-devel
BuildRequires:  libzrtpcpp-devel
BuildRequires:  make
BuildRequires:  openssl-devel
BuildRequires:  pcre-devel
BuildRequires:  perl-podlators
BuildRequires:  pjproject-devel
BuildRequires:  pulseaudio-libs-devel
BuildRequires:  rarian-compat
BuildRequires:  speex-devel
BuildRequires:  speexdsp-devel
BuildRequires:  systemd-devel
BuildRequires:  yelp-tools


%description
SFLphone is a robust standards-compliant enterprise software phone,
for desktop and embedded systems. It is designed to handle
several hundreds of calls a day. It supports both SIP and IAX2
protocols.


%package common
Summary:        Common files for SFLPhone
Requires:       %{name}-daemon = %{version}-%{release}
BuildArch:      noarch

%description common
SFLphone is a robust standards-compliant enterprise software phone,
for desktop and embedded systems. It is designed to handle
several hundreds of calls a day. It supports both SIP and IAX2
protocols.

This package includes common files for SFLPhone.


%package daemon
Summary:        SFLPhone daemon
Requires:       %{name}-common = %{version}-%{release}
Requires:       dbus%{?_isa}
Obsoletes:      %{name}-libs < 1.4.1-9

%description daemon
SFLphone is a robust standards-compliant enterprise software phone,
for desktop and embedded systems. It is designed to handle
several hundreds of calls a day. It supports both SIP and IAX2
protocols.

This package includes the SFLPhone daemon.


%package gnome
Summary:        SIP/IAX2 compatible enterprise-class software phone
Requires:       %{name}-daemon%{?_isa} = %{version}-%{release}
Requires:       hicolor-icon-theme

%description gnome
SFLphone is a robust standards-compliant enterprise software phone,
for desktop and embedded systems. It is designed to handle
several hundreds of calls a day. It supports both SIP and IAX2
protocols.

This package includes the Gnome client.


%package gnome-plugins
Summary:        Plugins (address book) for SFLphone
Requires:       %{name}-gnome%{?_isa} = %{version}-%{release}

%description gnome-plugins
SFLphone is a robust standards-compliant enterprise software phone,
for desktop and embedded systems. It is designed to handle
several hundreds of calls a day. It supports both SIP and IAX2
protocols.

This package includes the address book plugin.


%package kde
Summary:        KDE interface for SFLphone
Requires:       %{name}-daemon%{?_isa} = %{version}-%{release}
Requires:       hicolor-icon-theme
Requires:       kde-filesystem

%description kde
SFLphone is a robust standards-compliant enterprise software phone,
for desktop and embedded systems. It is designed to handle
several hundreds of calls a day. It supports both SIP and IAX2
protocols.

This package includes the KDE client.


%package kde-devel
Summary:        Development files for the KDE interface for SFLphone
Requires:       %{name}-kde%{?_isa} = %{version}-%{release}

%description kde-devel
SFLphone is a robust standards-compliant enterprise software phone,
for desktop and embedded systems. It is designed to handle
several hundreds of calls a day. It supports both SIP and IAX2
protocols.

This package includes the development files for the KDE client.


%prep
%autosetup -p1 -n %{name}-%{version}

# Unbundle bundled libraries
rm -rf daemon/libs

# Fix FSF addresses
find . -type f -print0 | xargs -0 sed -i 's|675 Mass Ave, Cambridge, MA 02139|51 Franklin Street, Fifth Floor, Boston, MA  02110-1301|'


%build
### Compile the daemon ###
pushd daemon
./autogen.sh
LDFLAGS="%{__global_ldflags} -Wl,--as-needed" %configure --disable-video
%make_build V=1
make doc
popd

### Compile gnome client ###
pushd gnome
./autogen.sh
LDFLAGS="%{__global_ldflags} -Wl,--as-needed" %configure --disable-video
%make_build V=1
popd

### Compile plugins ###
pushd plugins
./autogen.sh
LDFLAGS="%{__global_ldflags} -Wl,--as-needed" %configure
%make_build V=1
popd

### Compile kde client ###
mkdir kde/build
pushd kde/build
LDFLAGS="%{__global_ldflags} -Wl,--as-needed" %cmake ..
%make_build VERBOSE=1
popd


%install
%make_install -C daemon
%make_install -C gnome
%make_install -C plugins
%make_install -C kde/build

%find_lang sflphone --with-gnome
%find_lang sflphone-client-kde --with-kde -f sflphone-client-kde
%find_lang sflphone-kde --with-kde -f sflphone-kde

# Fix error: file contains group "Protocol", but groups extending the format should start with "X-"
sed -i 's|\[Protocol\]|\[X-Protocol\]|' %{buildroot}%{_datadir}/applications/kde4/sflphone-client-kde.desktop
desktop-file-validate %{buildroot}%{_datadir}/applications/%{name}.desktop

# Fix gzipped-svg-icon
(
cd %{buildroot}%{_datadir}/icons/hicolor/scalable/apps/
zcat sflphone-client-kde.svgz > sflphone-client-kde.svg && rm -f sflphone-client-kde.svgz
)

%ldconfig_scriptlets kde

%files common
%license COPYING
%doc daemon/AUTHORS NEWS README
%{_datadir}/%{name}/

%files daemon
%{_libdir}/%{name}/
%{_datadir}/dbus-1/services/org.%{name}.SFLphone.service
%exclude %{_libdir}/%{name}/plugins/
%{_mandir}/man1/sflphoned.1.gz*
%{_libexecdir}/sflphoned

%files gnome -f sflphone.lang
%{_bindir}/sflphone
%{_bindir}/sflphone-client-gnome
%{_datadir}/applications/%{name}.desktop
%{_datadir}/glib-2.0/schemas/org.sflphone.SFLphone.gschema.xml
%{_datadir}/icons/hicolor/scalable/apps/%{name}.svg
%{_mandir}/man1/sflphone.1.gz
%{_mandir}/man1/sflphone-client-gnome.1.gz

%files gnome-plugins
%{_libdir}/%{name}/plugins/

%files kde -f sflphone-client-kde -f sflphone-kde
%{_bindir}/sflphone-client-kde
%{_datadir}/applications/kde4/sflphone-client-kde.desktop
%{_datadir}/config.kcfg/sflphone-client-kde.kcfg
%{_datadir}/icons/hicolor/*/apps/sflphone-client-kde*
%{_datadir}/kde4/apps/sflphone-client-kde
%{_libdir}/libksflphone.so.*
%{_libdir}/libqtsflphone.so.*
%{_mandir}/man1/*kde*

%files kde-devel
%{_includedir}/ksflphone/
%{_includedir}/qtsflphone/
%{_libdir}/libksflphone.so
%{_libdir}/libqtsflphone.so


%changelog
* Tue May 21 2019 Milan Crha <mcrha@redhat.com> - 1.4.1-35
- Rebuild (evolution-data-server)

* Wed Apr 24 2019 Sandro Mani <manisandro@gmail.com> - 1.4.1-34
- Fix build against GCC9

* Sat Feb 02 2019 Fedora Release Engineering <releng@fedoraproject.org> - 1.4.1-33
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Sat Jul 14 2018 Fedora Release Engineering <releng@fedoraproject.org> - 1.4.1-32
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Mon Feb 19 2018 Sandro Mani <manisandro@gmail.com> - 1.4.1-31
- Add missing BR: gcc-c++, make

* Fri Feb 09 2018 Fedora Release Engineering <releng@fedoraproject.org> - 1.4.1-30
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Fri Jan 26 2018 Igor Gnatenko <ignatenkobrain@fedoraproject.org> - 1.4.1-29
- Fix ldconfig dependency

* Thu Jan 18 2018 Igor Gnatenko <ignatenkobrain@fedoraproject.org> - 1.4.1-28
- Remove obsolete scriptlets

* Wed Sep 06 2017 Sandro Mani <manisandro@gmail.com> - 1.4.1-27
- Add patch to fix deprecated dbus marshalling types

* Wed Sep 06 2017 Milan Crha <mcrha@redhat.com> - 1.4.1-26
- Add patch to adapt to pjspi API change

* Mon Aug 28 2017 Milan Crha <mcrha@redhat.com> - 1.4.1-25
- Add patch to not use --g-fatal-warnings for glib-genmarshal

* Thu Aug 03 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.4.1-24
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Binutils_Mass_Rebuild

* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.4.1-23
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Thu Feb 16 2017 Sandro Mani <manisandro@gmail.com> - 1.4.1-22
- Drop F22 conditionals
- Add patch to fix GCC7 FTBFS

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.4.1-21
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Mon Oct 31 2016 Sandro Mani <manisandro@gmail.com> - 1.4.1-20
- Rebuild (evolution-data-server)
- BR: dbus-glib-devel

* Sat Jul 23 2016 Sandro Mani <manisandro@gmail.com> - 1.4.1-19
- Rebuild (evolution-data-server)

* Fri Feb 05 2016 Sandro Mani <manisandro@gmail.com> - 1.4.1-18
- Add patch to fix FTBFS

* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 1.4.1-17
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Sat Dec 26 2015 Sandro Mani <manisandro@gmail.com> - 1.4.1-16
- Rebuild (ucommon)

* Thu Aug 06 2015 Sandro Mani <manisandro@gmail.com> - 1.4.1-15
- Rebuild (ucommon)

* Wed Jul 22 2015 Milan Crha <mcrha@redhat.com> - 1.4.1-14
- Rebuild for newer evolution-data-server

* Thu Jun 25 2015 Sandro Mani <manisandro@gmail.com> - 1.4.1-13
- Add patch to fix memory corruption issues (#1222301)

* Fri Jun 19 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.4.1-12
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Fri May 15 2015 Sandro Mani <manisandro@gmail.com> - 1.4.1-10
- Add patch to fix incorrect conditional in SipTransport::createTlsListener

* Wed May 06 2015 Sandro Mani <manisandro@gmail.com> - 1.4.1-9
- Install sflphoned in /usr/libexec
- Rename sflphone-libs -> sflphone-daemon

* Tue Apr 28 2015 Milan Crha <mcrha@redhat.com> - 1.4.1-8
- Rebuild for newer evolution-data-server

* Sat Apr 18 2015 Sandro Mani <manisandro@gmail.com> - 1.4.1-7
- Pass --disable-video to Gnome client configure

* Tue Feb 17 2015 Sandro Mani <manisandro@gmail.com> - 1.4.1-6
- Rebuild (evolution-data-server)

* Tue Jan 27 2015 Sandro Mani <manisandro@gmail.com> - 1.4.1-5
- Put org.sflphone.SFLphone.service in -libs package (it contains an arch specific path)

* Tue Jan 27 2015 Sandro Mani <manisandro@gmail.com> - 1.4.1-4
- Remove -Wl,--as-needed, makes the application crash with -Wl,-z,relro

* Mon Jan 26 2015 Sandro Mani <manisandro@gmail.com> - 1.4.1-3
- Set %%{__global_ldflags} in LDFLAGS override

* Thu Jan 22 2015 Sandro Mani <manisandro@gmail.com> - 1.4.1-2
- Use %%license
- Add Requires: dbus to sflphone-common
- Fixed ownership of %%{_datadir}/icons/hicolor, added Requires: hicolor-icon-theme
- Fixed ownership of %%{_datadir}/applications/kde4/
- Require sflphone-libs in sflphone-kde, sflphone-gnome, not sflphone-common
- Fix desktop file
- Add LDFLAGS="-Wl,--as-needed"
- Fix FSF addresses

* Sun Dec 14 2014 Sandro Mani <manisandro@gmail.com> - 1.4.1-1
- 1.4.1

* Sun Aug 10 2014 Sandro Mani <manisandro@gmail.com> - 1.4.0-1
- Initial package
